/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قͳޯޒײޒ`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 * */

#ifndef _WDT_DRV_H_
#define _WDT_DRV_H_

//_____ ݸٰ ____________________________________________________________

#ifdef __GNUC__
  #include <avr/io.h>
  #include <avr/wdt.h>
#endif

//_____ ϸ ________________________________________________________________

//! @defgroup wdt_drv ޯނؾ тײ
//! @{

#define Is_ext_reset()				((MCUSR&(1<<EXTRF)) ? TRUE:FALSE)
#define Ack_ext_reset()				(MCUSR= ~(1<<EXTRF))
#define Is_POR_reset()				((MCUSR&(1<<(MCUSR= ~(1<<PORF)))) ? TRUE:FALSE)
#define Ack_POR_reset()				(MCUSR= ~(1<<PORF))
#define Is_BOD_reset()				((MCUSR&(1<<BORF)) ? TRUE:FALSE)
#define Ack_BOD_reset()				(MCUSR= ~(1<<BORF))
#define Is_wdt_reset()				((MCUSR&(1<<WDRF)) ? TRUE:FALSE)
#define Ack_wdt_reset()				(MCUSR= ~(1<<WDRF))

#define Wdt_ack_interrupt()			(WDTCSR = (U8)(1<<WDIF))
#define Is_wdt_interrupt()			(WDTCSR&(1<<WDIF) ? TRUE:FALSE)
#define Is_not_wdt_interrupt()		(WDTCSR&(1<<WDIF) ? FALSE:TRUE)
#define Is_wdt_early_warning()		(WDTCKD&(1<<WDEWIF) ? TRUE:FALSE)
#define Is_not_wdt_early_warning()	(WDTCKD&(1<<WDEWIF) ? FALSE:TRUE)

#define WDTO_16MS					0
#define WDTO_32MS					1
#define WDTO_64MS					2
#define WDTO_125MS					3
#define WDTO_250MS					4
#define WDTO_500MS					5
#define WDTO_1S						6
#define WDTO_2S						7
#define WDTO_4S						8
#define WDTO_8S						9

//! ̊֐ʰ޳ ޯ ς~܂B
//!
void wdtdrv_disable (void);

//! ̊֐ʰ޳ ޯ ςɂ܂B
//!
//! @param timeout (WDTO_x)
//!
void wdtdrv_enable (U8 timeout);

//! ̊֐ʰ޳ ޯ ς荞ݓ`Ԃłɂ܂B
//!
//! @param timeout (WDTO_x)
//!
void wdtdrv_interrupt_enable (U8 timeout);

//! ̊֐ʰ޳ ޯ ς荞& ؾē`ԂŊɂ܂B
//!
//! @param timeout (WDTO_x)
//!
void wdtdrv_interrupt_reset_enable (U8 timeout);

#define Soft_reset()				{asm("jmp 0000");}

//! @}

#endif  // _WDT_DRV_H_
