/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSB KEYp̒ϸۂƒ`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 */

#ifndef USB_KEY_H
#define USB_KEY_H

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#if (TARGET_BOARD==USBKEY)

//_____ ϸ ________________________________________________________________

//! @defgroup USB_KEY_module USBKEY
//! ̕AT90USBkeyp̒ʰ޳ۑw܂݂܂B
//! @image html avrusbkey.gif
//! @{

	//! @defgroup USB_key_leds LEDǗ
	//! USB KEYLEDǗ邽߂ϸ
	//! LED0D2̐ԂɑΉ
	//! LED1D2̗΂ɑΉ
	//! LED2D5̗΂ɑΉ
	//! LED3D5̐ԂɑΉ
	//! @{
#define LED_PORT			PORTD
#define LED_DDR				DDRD
#define LED_PIN				PIND
#define LED0_BIT			PIND4
#define LED1_BIT			PIND5
#define LED2_BIT			PIND6
#define LED3_BIT			PIND7

#define Leds_init()			(LED_DDR |= (1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT))
#define Leds_on()			(LED_PORT |= (1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT))
#define Leds_off()			(LED_PORT &= ~((1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT)))
#define Leds_set_val(c)		(Leds_off(),LED_PORT |= (c<<4)&((1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT)))
#define Leds_get_val()		(LED_PORT>>4)

#define Led0_on()			(LED_PORT |=  (1<<LED0_BIT))
#define Led1_on()			(LED_PORT |=  (1<<LED1_BIT))
#define Led2_on()			(LED_PORT |=  (1<<LED2_BIT))
#define Led3_on()			(LED_PORT |=  (1<<LED3_BIT))
#define Led0_off()			(LED_PORT &= ~(1<<LED0_BIT))
#define Led1_off()			(LED_PORT &= ~(1<<LED1_BIT))
#define Led2_off()			(LED_PORT &= ~(1<<LED2_BIT))
#define Led3_off()			(LED_PORT &= ~(1<<LED3_BIT))
#define Led0_toggle()		(LED_PIN  |=  (1<<LED0_BIT))
#define Led1_toggle()		(LED_PIN  |=  (1<<LED1_BIT))
#define Led2_toggle()		(LED_PIN  |=  (1<<LED2_BIT))
#define Led3_toggle()		(LED_PIN  |=  (1<<LED3_BIT))
#define Is_led0_on()		(LED_PIN  &   (1<<LED0_BIT) ? TRUE : FALSE)
#define Is_led1_on()		(LED_PIN  &   (1<<LED1_BIT) ? TRUE : FALSE)
#define Is_led2_on()		(LED_PIN  &   (1<<LED2_BIT) ? TRUE : FALSE)
#define Is_led3_on()		(LED_PIN  &   (1<<LED3_BIT) ? TRUE : FALSE)
	//! @}

	//! @defgroup USB_key_joy ޮèǗ
	//! USB KEY̼ޮèǗ邽߂ϸ
	//! @{
#define Joy_init()			(DDRB &= ~((1<<PINB7)|(1<<PINB6)|(1<<PINB5)), PORTB |= ((1<<PINB7)|(1<<PINB6)|(1<<PINB5)), DDRE &= ~((1<<PINE5)|(1<<PINE4)), PORTE |= ((1<<PINE5)|(1<<PINE4)))

#define Is_btn_left()		Is_hwb()
#define Is_btn_middle()		((PINB & (1<<PINB5)) ?  FALSE : TRUE)
#define Is_btn_right()		FALSE

#define Is_joy_up()			((PINB & (1<<PINB7)) ?  FALSE : TRUE)
#define Is_joy_left()		((PINB & (1<<PINB6)) ?  FALSE : TRUE)
#define Is_joy_down()		((PINE & (1<<PINE5)) ?  FALSE : TRUE)
#define Is_joy_right()		((PINE & (1<<PINE4)) ?  FALSE : TRUE)

#define Is_btn_not_left()	Is_not_hwb()
#define Is_btn_not_middle()	((PINB & (1<<PINB5)) ?  TRUE : FALSE)
#define Is_btn_not_right()	TRUE

#define Is_joy_not_up()		((PINB & (1<<PINB7)) ?  TRUE  : FALSE)
#define Is_joy_not_left()	((PINB & (1<<PINB6)) ?  TRUE : FALSE)
#define Is_joy_not_down()	((PINE & (1<<PINE5)) ?  TRUE : FALSE)
#define Is_joy_not_right()	((PINE & (1<<PINE4)) ?  TRUE : FALSE)

//! (PB5`7)ɑ΂Ċ荞݋
//! - ɑ΂Ċ荞݂\ݒ
//! - ׸މ
//! - 荞݋
#define Switches_enable_it() { \
	PCMSK0 |= (1<<PCINT5)|(1<<PCINT6)|(1<<PCINT7);\
	PCIFR |= (1<<PCIF0);       \
	PCICR |= (1<<PCIE0);}

//! (PB5`7)ɑ΂Ċ荞݋֎~
//! - 荞݋֎~
//! - ׸މ
//! - Օ
#define Switches_disable_it() { \
	PCICR  &= ~(1<<PCIE0);      \
	PCIFR  |= (1<<PCIF0);       \
	PCMSK0 &= ~((1<<PCINT5)|(1<<PCINT6)|(1<<PCINT7));}
	//! @}

	//! @defgroup USB_key_HWB HWBtǗ
	//! HWBtPE2ɐڑAWtƂĂgpł܂B
	//! @{
#define Hwb_button_init()	(DDRE  &= ~(1<<PINE2), PORTE |= (1<<PINE2))
#define Is_hwb()			((PINE &   (1<<PINE2)) ?  FALSE : TRUE)
#define Is_not_hwb()		((PINE &   (1<<PINE2)) ?  TRUE : FALSE)
	//! @}

	//! @defgroup USB_key_df USB KEYʰ޳ DataFlash`Ԑݒ
	//! USB KEYDataFlashɑ΂Ċ邽߂ϸ
	//! @{

// 1AT45DB642D
#define DF_8_MB
#define DF_NB_MEM			2

// PINB0 : SPI]uI݁A݂͂ꂪޮèɂĎgp邽߁A֎~(͌`ԋ֎~)Ȃ΂Ȃ܂B
//		   : ٱߒRɂ݂قǂނƂł邽߁Aޮè͏o͌`Ԃŏ肭Ƃł܂B
// PINB1 : SCKM̕͏o͂łB
// PINB2 : SIM̕͏o͂łB
// PINB3 : SOM͓͂̕łB
// PINE0 : CS0M̕͏o͂łB
// PINE1 : CS1M̕͏o͂łB
#define Df_init_spi()		(DDRB  &= ~((1<<PINB3)), \
							 DDRB  |=  ((1<<PINB2)|(1<<PINB1)|(1<<PINB0)), \
							 PORTB |=  ((1<<PINB3)|(1<<PINB2)|(1<<PINB1)|(1<<PINB0)), \
							 DDRE  |=  ((1<<PINE1)|(1<<PINE0)), \
							 PORTE |=  ((1<<PINE1)|(1<<PINE0)) )
#define Df_select_0()		(PORTE &= ~(1<<PINE0))
#define Df_select_1()		(PORTE &= ~(1<<PINE1))
#define Df_desel_all()		(PORTE |=  ((1<<PINE1)|(1<<PINE0)))
	//! @}

//! @}

// USB KEY ADCْ`
#define ADC_TEMP_CH			0x00

#ifdef USE_ADC								//!< ̒`config.ḩقŐݒ肳܂B

//! @brief ̊֐USB KEỶxقA/DϊsU16l10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return U16 ۸ފm퉷xl
//!
U16 Get_adc_temp_val (void);

//! @brief ̊֐USB KEỶxقA/DϊsU16l(ł)x10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return S16 ł̉xl
//!
S16 Read_temperature (void);

#endif // USE_ADC

#endif // TARGET_BOARD==USBKEY

#endif // USB_KEY_H
