/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBײޒ`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 * */

#ifndef _USB_DRV_H_
#define _USB_DRV_H_

//_____ ݸ- ____________________________________________________________

typedef enum endpoint_parameter{ep_num, ep_type, ep_direction, ep_size, ep_bank, nyet_status} t_endpoint_parameter;

//! @defgroup USB_low_level_drivers USBײ
//! USBײޒPʕ
//! @{

//_____ ϸ ________________________________________________________________

#define MAX_EP_NB				7

#define EP_CONTROL				0
#define EP_1					1
#define EP_2					2
#define EP_3					3
#define EP_4					4
#define EP_5					5
#define EP_6					6
#define EP_7					7

#define PIPE_CONTROL			0
#define PIPE_0					0
#define PIPE_1					1
#define PIPE_2					2
#define PIPE_3					3
#define PIPE_4					4
#define PIPE_5					5
#define PIPE_6					6
#define PIPE_7					7

// USB߲
#define MSK_EP_DIR				0x7F
#define MSK_UADD				0x7F
#define MSK_EPTYPE				0xC0
#define MSK_EPSIZE				0x70
#define MSK_EPBK				0x0C
#define MSK_DTSEQ				0x0C
#define MSK_NBUSYBK				0x03
#define MSK_CURRBK				0x03
#define MSK_DAT					0xFF	// UEDATX
#define MSK_BYCTH				0x07	// UEBCHX
#define MSK_BYCTL				0xFF	// UEBCLX
#define MSK_EPINT				0x7F	// UEINT
#define MSK_HADDR				0xFF	// UHADDR

// USB߲
#define MSK_PNUM				0x07	// UPNUM
#define MSK_PRST				0x7F	// UPRST
#define MSK_PTYPE				0xC0	// UPCFG0X
#define MSK_PTOKEN				0x30
#define MSK_PEPNUM				0x0F
#define MSK_PSIZE				0x70	// UPCFG1X
#define MSK_PBK					0x0C

#define MSK_NBUSYBK				0x03

#define MSK_ERROR				0x1F

#define MSK_PTYPE				0xC0	// UPCFG0X
#define MSK_PTOKEN				0x30
#define MSK_TOKEN_SETUP			0x30
#define MSK_TOKEN_IN			0x10
#define MSK_TOKEN_OUT			0x20
#define MSK_PEPNUM				0x0F

#define MSK_PSIZE				0x70	// UPCFG1X
#define MSK_PBK					0x0C

// ߲č\ݒpҰ
// ̒`ʹ߲Ă̋ƍ\ݒɎgplłB
#define TYPE_CONTROL			0
#define TYPE_ISOCHRONOUS		1
#define TYPE_BULK				2
#define TYPE_INTERRUPT			3
//typedef enum ep_type {TYPE_CONTROL, TYPE_BULK, TYPE_ISOCHRONOUS, TYPE_INTERRUPT} e_ep_type;

#define DIRECTION_OUT			0
#define DIRECTION_IN			1
//typedef enum ep_dir {DIRECTION_OUT, DIRECTION_IN} e_ep_dir;

#define SIZE_8					0
#define SIZE_16					1
#define SIZE_32					2
#define SIZE_64					3
#define SIZE_128				4
#define SIZE_256				5
#define SIZE_512				6
#define SIZE_1024				7
 //typedef enum ep_size {SIZE_8,   SIZE_16,  SIZE_32,  SIZE_64,
 //                      SIZE_128, SIZE_256, SIZE_512, SIZE_1024} e_ep_size;

#define ONE_BANK				0
#define TWO_BANKS				1
//typedef enum ep_bank {ONE_BANK, TWO_BANKS} e_ep_bank;

#define NYET_ENABLED			0
#define NYET_DISABLED			1
//typedef enum ep_nyet {NYET_DISABLED, NYET_ENABLED} e_ep_nyet;

#define TOKEN_SETUP				0
#define TOKEN_IN				1
#define TOKEN_OUT				2

#define Is_ep_addr_in(x)		(  (x&USB_ENDPOINT_DIR_MASK)?   TRUE : FALSE)

//! @defgroup Endpoints_configuration ߲ėp\ݒϸ
//! ߲߂ƴ߲Ă\ݒ肷̂ɎgpWϸۂ̈ꗗ
//! @{
#define Usb_build_ep_config0(type, dir, nyet) ((type<<6) | (nyet<<1) | (dir))
#define Usb_build_ep_config1(size, bank     ) ((size<<4) | (bank<<2)        )
#define usb_configure_endpoint(num, type, dir, size, bank, nyet)             \
									( Usb_select_endpoint(num),              \
									  usb_config_ep(Usb_build_ep_config0(type, dir, nyet),\
													Usb_build_ep_config1(size, bank)    ))

#define Host_build_pipe_config0(type, token, ep_num)	((type<<6) | (token<<4) | (ep_num))
#define Host_build_pipe_config1(size, bank     )		((size<<4) | (bank<<2)        )
#define host_configure_pipe(num, type, token,ep_num, size, bank, freq)             \
									( Host_select_pipe(num),              \
									  Host_set_interrupt_frequency(freq), \
									  host_config_pipe(Host_build_pipe_config0(type, token, ep_num),\
									  Host_build_pipe_config1(size, bank)    ))
//! @}

//! @defgroup USB_regulator USB߯ޓdײ
//! USB߯ޓdON/OFF؂ւ
//! @{
#define Usb_enable_regulator()			(REGCR &= ~(1<<REGDIS))	//!< USB߯ޓd틖
#define Usb_disable_regulator()			(REGCR |=  (1<<REGDIS))	//!< USB߯ޓd֎~
#define Is_usb_regulator_enabled()		((REGCR &  (1<<REGDIS)) ? FALSE : TRUE)	//!< d틖ޯČ
//! @}

//! @defgroup gen_usb USBʊǗײ
//! ϸۂUSBǗ܂B
//! @{

#define Usb_enable()					(USBCON |=  ((1<<USBE)))	//!< USB̪
#define Usb_disable()					(USBCON &= ~((1<<USBE)))	//!< USB̪֎~
#define Is_usb_enabled()				((USBCON &  (1<<USBE)) ? TRUE : FALSE)

#define Usb_enable_device()				(USBCON |= (1<<USBE))
#define Usb_disable_device()			(USBCON &= ~(1<<USBE))
#define Usb_reset_macro_only()			(UDCON &= ~(1<<RSTCPU))
#define Usb_reset_all_system()			(UDCON |= (1<<RSTCPU))

#if (VBUS_SENSING_IO == ENABLED)
  #define Usb_vbus_sense_init()			(VBUS_SENSE_DDR &= ~(1<<VBUS_SENSE_IO), \	//!< VBUSmI/O
										 VBUS_SENSE_PORT &= ~(1<<VBUS_SENSE_IO))
  #define Is_usb_vbus_on()				(((VBUS_SENSE_PIN&(1<<VBUS_SENSE_IO)) != 0) ? TRUE : FALSE)	//!< VBUS݂
  #define Is_usb_vbus_off()				(((VBUS_SENSE_PIN&(1<<VBUS_SENSE_IO)) == 0) ? TRUE : FALSE)	//!< VBUSs݂
#endif

#define Usb_freeze_clock()				(USBCON  |=  (1<<FRZCLK))	//! ̪̓USBۯ~(̪ ڼ޽)
#define Usb_unfreeze_clock()			(USBCON  &= ~(1<<FRZCLK))
#define Is_usb_clock_freezed()			((USBCON  &  (1<<FRZCLK)) ? TRUE : FALSE)

#define Ps2_enable_device()				(PS2CON |= (1<<PS2EN))
#define Ps2_disable_device()			(PS2CON &= ~(1<<PS2EN))

#define Usb_direct_drive_usb_enable()	(UPOE |=   (1<<UPWE1), UPOE &= ~(1<<UPWE0))
#define Usb_direct_drive_ps2_enable()	(UPOE |=  ((1<<UPWE1) | (1<<UPWE0)))
#define Usb_direct_drive_disable()		(UPOE &= ~((1<<UPWE1) | (1<<UPWE0)))
#define Usb_drive_dp_high()				(UPOE |=   (1<<UPDRV1))
#define Usb_drive_dp_low()				(UPOE &=  ~(1<<UPDRV1))
#define Usb_drive_dm_high()				(UPOE |=   (1<<UPDRV0))
#define Usb_drive_dm_low()				(UPOE &=  ~(1<<UPDRV0))
#define Ps2_drive_sck_high()			(UPOE |=   (1<<UPDRV1))
#define Ps2_drive_sck_low()				(UPOE &=  ~(1<<UPDRV1))
#define Ps2_drive_data_high()			(UPOE |=   (1<<UPDRV0))
#define Ps2_drive_data_low()			(UPOE &=  ~(1<<UPDRV0))

#define MSK_IDTE_VBUSTE						((1<<IDTE)|(1<<VBUSTE))
#define Usb_get_general_interrupt()			(USBINT & (USBCON & MSK_IDTE_VBUSTE))	//!< USBSʊ荞(ꂽ荞)ԂB
#define Usb_ack_all_general_interrupt()		(USBINT = ~(USBCON & MSK_IDTE_VBUSTE))	//!< USBSʊ荞(ꂽ荞)
#define Usb_ack_cache_id_transition(x)		((x)  &= ~(1<<IDTI))
#define Usb_ack_cache_vbus_transition(x)	((x)  &= ~(1<<VBUSTI))
#define Is_usb_cache_id_transition(x)		(((x) &   (1<<IDTI))  )
#define Is_usb_cache_vbus_transition(x)		(((x) &   (1<<VBUSTI)))
//! @}

//! @defgroup USB_device_driver USBuײ
//! ϸۂUSBuǗ܂B
//! @{
#define Usb_initiate_remote_wake_up()			(UDCON   |=  (1<<RMWKUP))	//!< uNJn
#define Usb_detach()							(UDCON   |=  (1<<DETACH))	//!< USB޽ؒf
#define Usb_attach()							(UDCON   &= ~(1<<DETACH))	//!< USB޽ɐڑ
#define Is_usb_pending_remote_wake_up()			((UDCON & (1<<RMWKUP)) ? TRUE : FALSE)	//!< uNs
#define Is_usb_detached()						((UDCON & (1<<DETACH)) ? TRUE : FALSE)	//!< uؒfĂ邩

#define Usb_get_device_interrupt()				(UDINT &  (1<<UDIEN))	//!< USBu荞(Ă銄荞)Ԃ܂B
#define Usb_ack_all_device_interrupt()			(UDINT = ~(1<<UDIEN))	//!< USBu荞(Ă銄荞)

#define Usb_enable_remote_wake_up_interrupt()	(UDIEN |=  (1<<UPRSME))	//!< uN荞݋
#define Usb_disable_remote_wake_up_interrupt()	(UDIEN &= ~(1<<UPRSME))	//!< uN荞݋֎~
#define Is_remote_wake_up_interrupt_enabled()	((UDIEN &  (1<<UPRSME)) ? TRUE : FALSE)
#define Usb_ack_remote_wake_up_start()			(UDINT  = ~(1<<UPRSMI))	//!< uN
#define Is_usb_remote_wake_up_start()			((UDINT &  (1<<UPRSMI)) ? TRUE : FALSE)	//!< uNs

#define Usb_enable_resume_interrupt()			(UDIEN  |=  (1<<EORSME))	//!< ĊJ荞݋
#define Usb_disable_resume_interrupt()			(UDIEN  &= ~(1<<EORSME))	//!< ĊJ荞݋֎~
#define Is_resume_interrupt_enabled()			((UDIEN &   (1<<EORSME)) ? TRUE : FALSE)
#define Usb_ack_resume()						(UDINT   = ~(1<<EORSMI))	//!< ĊJ
#define Is_usb_resume()							((UDINT &   (1<<EORSMI)) ? TRUE : FALSE)	//!< ĊJN

#define Usb_enable_wake_up_interrupt()			(UDIEN  |=  (1<<WAKEUPE))	//!< Nオ芄荞݋
#define Usb_disable_wake_up_interrupt()			(UDIEN  &= ~(1<<WAKEUPE))	//!< Nオ芄荞݋֎~
#define Is_wake_up_interrupt_enabled()			((UDIEN &   (1<<WAKEUPE)) ? TRUE : FALSE)
#define Usb_ack_wake_up()						(UDINT   = ~(1<<WAKEUPI))	//!< Nオ艞
#define Is_usb_wake_up()						((UDINT &   (1<<WAKEUPI)) ? TRUE : FALSE)	//!< Nオ肪N

#define Usb_enable_reset_interrupt()			(UDIEN  |=  (1<<EORSTE))	//!< USBؾĊ荞݋
#define Usb_disable_reset_interrupt()			(UDIEN  &= ~(1<<EORSTE))	//!< USBؾĊ荞݋֎~
#define Is_reset_interrupt_enabled()			((UDIEN &   (1<<EORSTE)) ? TRUE : FALSE)
#define Usb_ack_reset()							(UDINT   = ~(1<<EORSTI))	//!< USBؾĉ
#define Is_usb_reset()							((UDINT &   (1<<EORSTI)) ? TRUE : FALSE)	//!< USBؾĂN

#define Usb_enable_sof_interrupt()				(UDIEN  |=  (1<<SOFE))	//!< ڰъJn荞݋
#define Usb_disable_sof_interrupt()				(UDIEN  &= ~(1<<SOFE))	//!< ڰъJn荞݋֎~
#define Is_sof_interrupt_enabled()				((UDIEN &   (1<<SOFE)) ? TRUE : FALSE)
#define Usb_ack_sof()							(UDINT   = ~(1<<SOFI))	//!< ڰъJn
#define Is_usb_sof()							((UDINT &   (1<<SOFI)) ? TRUE : FALSE)	//!< ڰъJnN

#define Usb_enable_suspend_interrupt()			(UDIEN  |=  (1<<SUSPE))	//!< x~Ԋ荞݋
#define Usb_disable_suspend_interrupt()			(UDIEN  &= ~(1<<SUSPE))	//!< x~Ԋ荞݋֎~
#define Is_suspend_interrupt_enabled()			((UDIEN &   (1<<SUSPE)) ? TRUE : FALSE)	//!< x~荞݂
#define Usb_ack_suspend()						(UDINT   = ~(1<<SUSPI))	//!< x~
#define Is_usb_suspend()						((UDINT &   (1<<SUSPI)) ? TRUE : FALSE)	//!< x~Ԍo

#define Usb_enable_address()					(UDADDR  |=  (1<<ADDEN))	//!< USBuڽ
#define Usb_disable_address()					(UDADDR  &= ~(1<<ADDEN))	//!< USBuڽ֎~
#define Is_usb_addressed()						((UDADDR &   (1<<ADDEN)) ? TRUE : FALSE)	//!< uڽw肳Ă邩
#define Usb_configure_address(addr)				(UDADDR  = (UDADDR & (1<<ADDEN)) | ((U8)addr & MSK_UADD))	//!< USBuڽݒ

#define Usb_frame_number()						((U16)((((U16)UDFNUMH) << 8) | ((U16)UDFNUML)))	//!< ŏIڰєԍԂB
#define Is_usb_frame_number_crc_error()			((UDMFN & (1<<FNCERR)) ? TRUE : FALSE)	//!< ڰєԍCRCُ픭
//! @}

//! @defgroup usb_gen_ep USB߲ ײ
//! ϸۂʹ߲Ă̋ʋ@\Ǘ܂B
//! @{
#define Usb_select_endpoint(ep)					(UENUM = (U8)ep)	//!< CPUƂŲ̪邽߂̴߲ĔԍI
#define Usb_get_selected_endpoint()				(UENUM)	//!< ݑIĂ߲Ĕԍ擾
#define Usb_reset_endpoint(ep)					(UERST = 1 << (U8)ep, UERST = 0)	//!< I߲Ăؾ

#define Usb_enable_endpoint()					(UECONX  |=  (1<<EPEN))		//!< ̴݂߲Ă
#define Usb_enable_stall_handshake()			(UECONX  |=  (1<<STALLRQ))	//!< ̒Pʓ]ɑ΂STALL޼
#define Usb_reset_data_toggle()					(UECONX  |=  (1<<RSTDT))	//!< ްݐ؂ւ菇ؾ
#define Usb_disable_endpoint()					(UECONX  &= ~(1<<EPEN))		//!< ̴݂߲Ă֎~
#define Usb_disable_stall_handshake()			(UECONX  |=  (1<<STALLRQC))	//!< STALL޼֎~
#define Usb_select_epnum_for_cpu()				(UECONX  &= ~(1<<EPNUMS))	//!< CPU̴߲ ̪I
#define Is_usb_endpoint_enabled()				((UECONX & (1<<EPEN))    ? TRUE : FALSE)	//!< ̴݂߲ĂĂ邩
#define Is_usb_endpoint_stall_requested()		((UECONX & (1<<STALLRQ)) ? TRUE : FALSE)	//!< STALL޼vs

#define Usb_configure_endpoint_type(type)		(UECFG0X = (UECFG0X & ~(MSK_EPTYPE)) | ((U8)type << 6))	//!< ̴݂߲Ă`Ԑݒ
#define Usb_configure_endpoint_direction(dir)	(UECFG0X = (UECFG0X & ~(1<<EPDIR))   | ((U8)dir))		//!< ̴݂߲ĕ`Ԑݒ

#define Usb_configure_endpoint_size(size)		(UECFG1X =   (UECFG1X & ~MSK_EPSIZE) | ((U8)size << 4))	//!< ̴݂߲Ă̑傫`Ԑݒ
#define Usb_configure_endpoint_bank(bank)		(UECFG1X =   (UECFG1X & ~MSK_EPBK)   | ((U8)bank << 2))	//!< ̴݂߲Ăݸ`Ԑݒ
#define Usb_allocate_memory()					(UECFG1X |=  (1<<ALLOC))	//!< DPRAMŌ݂̌`Ԑݒ蓖
#define Usb_unallocate_memory()					(UECFG1X &= ~(1<<ALLOC))	//!< DPRAMŌ݂̌`Ԑݒ蓖ĉ

#define Usb_ack_overflow_interrupt()			(UESTA0X &= ~(1<<OVERFI))	//!< ߲Ĉꊄ荞݉
#define Usb_ack_underflow_interrupt()			(UESTA0X &= ~(1<<UNDERFI))	//!< ߲ĘRꊄ荞݉
#define Usb_ack_zlp()							(UESTA0X &= ~(1<<ZLPSEEN))	//!< 0߹(ZLP)M
#define Usb_data_toggle()						((UESTA0X&MSK_DTSEQ) >> 2)	//!< ްݐ؂ւlԂB
#define Usb_nb_busy_bank()						(UESTA0X &   MSK_NBUSYBK)	//!< ZݸԂB
#define Is_usb_one_bank_busy()					((UESTA0X &  MSK_NBUSYBK) == 0 ? FALSE : TRUE)	//!< Œ1ݸZ
#define Is_endpoint_configured()				((UESTA0X &  (1<<CFGOK))   ? TRUE : FALSE)	//!< ̴݂߲Ă`Ԑݒ肳Ă邩
#define Is_usb_overflow()						((UESTA0X &  (1<<OVERFI))  ? TRUE : FALSE)	//!< ꔭ
#define Is_usb_underflow()						((UESTA0X &  (1<<UNDERFI)) ? TRUE : FALSE)	//!< Rꔭ
#define Is_usb_zlp()							((UESTA0X &  (1<<ZLPSEEN)) ? TRUE : FALSE)	//!< ZLPoꂽ

#define Usb_control_direction()					((UESTA1X &  (1<<CTRLDIR)) >> 2)	//!< ԂB
#define Usb_current_bank()						( UESTA1X & MSK_CURRBK)			//!< ݂ݸԍԂB

#define Usb_ack_fifocon()						(UEINTX &= ~(1<<FIFOCON))	//!< FIFOCONޯĂ
#define Usb_ack_nak_in()						(UEINTX &= ~(1<<NAKINI))	//!< NAK INM
#define Usb_ack_nak_out()						(UEINTX &= ~(1<<NAKOUTI))	//!< NAK OUTM
#define Usb_ack_receive_setup()					(UEINTX &= ~(1<<RXSTPI))	//!< SETUPM
#define Usb_ack_receive_out()					(UEINTX &= ~(1<<RXOUTI), Usb_ack_fifocon())	//!< OUTM
#define Usb_ack_stalled()						(MSK_STALLEDI=0)		//!< STALLo
#define Usb_ack_in_ready()						(UEINTX &= ~(1<<TXINI), Usb_ack_fifocon())	//!< IN
#define Usb_kill_last_in_bank()					(UENTTX |= (1<<RXOUTI))	//!< ŌݸEB
#define Is_usb_read_enabled()					(UEINTX&(1<<RWAL))		//!< ߲Ăǂݍ݉
#define Is_usb_write_enabled()					(UEINTX&(1<<RWAL))		//!< ߲Ă݉
#define Is_usb_read_control_enabled()			(UEINTX&(1<<TXINI))		//!< ߲Ăœǂݍ݉
#define Is_usb_nak_in_sent()					(UEINTX&(1<<NAKINI))	//!< IN߲ĂNAKꂽ
#define Is_usb_nak_out_sent()					(UEINTX&(1<<NAKOUTI))	//!< OUT߲ĂNAKꂽ
#define Is_usb_receive_setup()					(UEINTX&(1<<RXSTPI))	//!< SETUPMꂽ
#define Is_usb_receive_out()					(UEINTX&(1<<RXOUTI))	//!< OUTMꂽ
#define Is_usb_in_ready()						(UEINTX&(1<<TXINI))		//!< IN
#define Usb_send_in()							(UEINTX &= ~(1<<FIFOCON))	//!< INo
#define Usb_send_control_in()					(UEINTX &= ~(1<<TXINI))		//!< ߲ĂINo
#define Usb_free_out_bank()						(UEINTX &= ~(1<<FIFOCON))	//!< OUTݸJ
#define Usb_ack_control_out()					(UEINTX &= ~(1<<RXOUTI))	//!< ߲ĂOUT

#define Usb_enable_flow_error_interrupt()		(UEIENX |=  (1<<FLERRE))	//!< ُ튄荞݋
#define Usb_enable_nak_in_interrupt()			(UEIENX |=  (1<<NAKINE))	//!< NAK IN荞݋
#define Usb_enable_nak_out_interrupt()			(UEIENX |=  (1<<NAKOUTE))	//!< NAK OUT荞݋
#define Usb_enable_receive_setup_interrupt()	(UEIENX |=  (1<<RXSTPE))	//!< SETUPM荞݋
#define Usb_enable_receive_out_interrupt()		(UEIENX |=  (1<<RXOUTE))	//!< OUTM荞݋
#define Usb_enable_stalled_interrupt()			(UEIENX |=  (1<<STALLEDE))	//!< STALLo荞݋
#define Usb_enable_in_ready_interrupt()			(UEIENX |=  (1<<TXIN))		//!< IN荞݋
#define Usb_disable_flow_error_interrupt()		(UEIENX &= ~(1<<FLERRE))	//!< ُ튄荞݋֎~
#define Usb_disable_nak_in_interrupt()			(UEIENX &= ~(1<<NAKINE))	//!< NAK IN荞݋֎~
#define Usb_disable_nak_out_interrupt()			(UEIENX &= ~(1<<NAKOUTE))	//!< NAK OUT荞݋֎~
#define Usb_disable_receive_setup_interrupt()	(UEIENX &= ~(1<<RXSTPE))	//!< SETUPM荞݋֎~
#define Usb_disable_receive_out_interrupt()		(UEIENX &= ~(1<<RXOUTE))	//!< OUTM荞݋֎~
#define Usb_disable_stalled_interrupt()			(UEIENX &= ~(1<<STALLEDE))	//!< STALLo荞݋֎~
#define Usb_disable_in_ready_interrupt()		(UEIENX &= ~(1<<TXIN))		//!< IN荞݋֎~

#define Usb_read_byte()							(UEDATX)			//!< ̴݂߲ėpFIFO޲ĂԂB
#define Usb_write_byte(byte)					(UEDATX = (U8)byte)	//!< ̴݂߲ėpFIFO޲ď

#define Usb_byte_counter()						((U8)(UEBCLX))	//!< ̴݂߲FIFO޲ĐԂ(16ޯ)B
#define Usb_byte_counter_8()					((U8)UEBCLX)	//!< ̴݂߲FIFO޲ĐԂ(8ޯ)B

#define Usb_interrupt_flags()					(UEINT)							//! Sʴ߲Ċ荞׸ތ
#define Is_usb_endpoint_event()					(Usb_interrupt_flags() != 0x00)	//! Sʴ߲Ċ荞׸ތ
//! @}

//! ϸۂ͌̏U8܂B
//!
//! @param	x	(U16) 16ޯČ
//!
//! @return		(U16) ꂽ2޲Ă16ޯČ

#define wSWAP(x)        \
   (   (((x)>>8)&0x00FF) \
   |   (((x)<<8)&0xFF00) \
   )

//! Usb_write_word_enum_struc
//! ϸۂUSB(ڑmF)\̂U16lŖ̂菕܂B
//! CPU{\ɈˑāAϸۂق邩A܂͂܂B
//!
//! @param	x	(U16) ׂ16ޯČ
//!
//! @return		(U16) ꂽ16ޯČ
#if !defined(BIG_ENDIAN) && !defined(LITTLE_ENDIAN)
  #error YOU MUST Define the Endian Type of target: LITTLE_ENDIAN or BIG_ENDIAN
#endif
#ifdef LITTLE_ENDIAN
  #define Usb_write_word_enum_struc(x)   (x)
#else //BIG_ENDIAN
  #define Usb_write_word_enum_struc(x)   (wSWAP(x))
#endif

//! @}

//_____ 錾 _______________________________________________________________

U8		usb_config_ep					(U8, U8);
U8		usb_select_enpoint_interrupt	(void);
U16		usb_get_nb_byte_epw				(void);
U8		usb_send_packet					(U8 , U8*, U8);
U8		usb_read_packet					(U8 , U8*, U8);
void	usb_halt_endpoint				(U8);
void	usb_reset_endpoint				(U8);
U8		usb_init_device					(void);

#endif  // _USB_DRV_H_
