/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͕WHID IN/OUTƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "hid_task.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#include "lib_mcu/util/start_boot.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

volatile	U8	cpt_sof			=0;
extern		U8	jump_bootloader;
			U8	g_last_joy		=0;

void hid_report_out  (void);
void hid_report_in   (void);

//! @brief ̊֐͖ړIΏۊ̎܂B
//!
void hid_task_init (void)
{
	Leds_init();
	Joy_init();
}

//! @brief HIDWʐMƂ̓_
//! ̊֐IN/OUT񍐊ǗǗ܂B
//!
void hid_task (void)
{
	if(!Is_device_enumerated())			// USB HID(ڑF)ꂽ
		return;

	hid_report_out();
	hid_report_in();
}

//! @brief νĂް񍐂擾
//!
void hid_report_out (void)
{
	Usb_select_endpoint(EP_HID_OUT);
	if(Is_usb_receive_out())
	{
		//* WHID̕񍐓ǂݍ
		U8 led_state;
		U8 led_number;
		led_state  = Usb_read_byte()&0x0F;		// RepportOUT[0]LEDSl
		led_number = Usb_read_byte()&0x0F;
		switch (led_number)
		{
			case 1:
				if(led_state)
				{  Led0_on();   }
				else {Led0_off();}
				break;
			case 2:
				if(led_state)
				{  Led1_on();   }
				else {Led1_off();}
				break;
			case 3:
				if(led_state)
				{  Led2_on();   }
				else {Led2_off();}
				break;
		}
		Usb_ack_receive_out();
	}

	//** νĂDFU얽߂M
	if(jump_bootloader)
	{
		U32 volatile tempo;
		Leds_off();
		Usb_detach();						// ۂ̕WHIDpO
		for(tempo=0;tempo<70000;tempo++);	// 鎞ԑҋ@
		start_boot();						// ް۰ނ֕
	}
}

//! @brief νĂް񍐂𑗏o
//!
void hid_report_in (void)
{
	U8 joy   =0;

	Usb_select_endpoint(EP_HID_IN);
	if(!Is_usb_write_enabled())
		return;						// 񍐑ȍs

	// ޮè񍐂\z
	if(Is_joy_down())
	{
		joy=0x01;
	}
	if(joy==g_last_joy)
		return;						// 񍐂ŕ񍐑oȂ
	g_last_joy=joy;

	// 񍐑o
	Usb_write_byte(g_last_joy);		// ޮè
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_write_byte(GPIOR1);			// U(sgp)
	Usb_ack_in_ready();				// USBްo
}

//! @brief ̊֐USBڰъ荞ݻٰ݂s(1ms)cpt_sofv
//! ܂BԒx̊ǗɗLpłB
//!
void sof_action ()
{
	cpt_sof++;
}
